#ifndef _INITIALIZATION_H_
#define _INITIALIZATION_H_

#include "ArduPar.h"
#include "avr/eeprom.h"
#include "SoftwareSerial.h"




SoftwareSerial mySerial(13, 12);

IntArduPar someZ;
IntArduPar someX;

void initialization()
{
                    
                    Serial.begin(115200); //start Serial Communication
                    pinMode(13,OUTPUT);   //some output.
                                          //we need to set up the someIntSetting to make it useful:
                    someX.setup(F("someX"), -1000, 1000); //empfängt alle Z werte der Kinect(Z ist der Abstand der Kinect zu dem erechneten mittelpunkt einer getrackten Person)
                  
                      
                      
                      // The command used to change the parameter. The F("foo") syntax saves memory by putting the command into flash-memory. (look up "progmem strings" if you care)
                      // The lowest value the parameter can have. Values received via Serial will be clipped to this range.
                      // The highest value the parameter can have. Values received via Serial will be clipped to this range.
                      
                     
                    someZ.setup(F("someZ"), 0, 5000); // empfängt alle X werte der Kinect (X ist Indikator dafür wie weit nach rechts oder links eine getrackte Person zur Kinect steht)
                     
        
                    digitalWrite(13,LOW);   
                     
                     // set the data rate for the SoftwareSerial port
                    mySerial.begin(115200);
                    // further Data-Query Commands: http://www.pololu.com/file/download/TReX_Commands_v1.2.pdf?file_id=0J1
                    mySerial.write(0x83);
                    
                    delay(100);
                    
                                  if(mySerial.read() == 1)
                                  {
                                    
                                      Serial.println("Serial is in control!");
                                    
                                  }
                                  
                                  else
                                  {
                                    
                                      Serial.println("Serial ist not in control!");
                                    
				 }
                                 // Serial.println('x');
                                  

}

#endif
