#ifndef __MOTOR_H_
#define __MOTOR_H_


#include <ArduPar.h>
#include <avr/eeprom.h>
#include <SoftwareSerial.h>
#include <Timer.h>

int aktGeschw = 0;
int led = 13;

/////////////////////////////////////////////////////////  motor  /////////////////////////////////////////////////////////


  void blinken(int wiederholungen, int geschwindigkeit) // z.B. für standby o. Kontrolle von werten da zur Laufzeit der Port von kinect besetzt ist und damit der Serial Monitor nicht benutzbar ist
  {
    
                  for(int i=0; i < wiederholungen;i++)
                  { 
                    
                        digitalWrite(led, HIGH); // turn the LED on (HIGH is the voltage level)
                        delay(geschwindigkeit);
                        digitalWrite(led, LOW); // turn the LED off by making the voltage LOW
                        delay(geschwindigkeit);
                        
                  }
                  
  }
  
  void vorwaerts(int zielGeschw){ // läst den Roboter vorwärts fahren abhängig von der aktuellen Geschwindigkeit um das Wackeln zu reduzieren
 int wdh = abs((zielGeschw - aktGeschw)/10); // Berechnung der schleifenwiederholugen
  for(int i=0; i<wdh; i++){
    if(aktGeschw < zielGeschw)
      aktGeschw += 10;
    else
      aktGeschw -= 10;
    mySerial.write(0xC2); 
    mySerial.write(aktGeschw); 
    mySerial.write(0xCA);
    mySerial.write(aktGeschw); 
    delay(200);
  }
}

void rueckwaerts(int zielGeschw){ // wie vorwaerts ...nur rückwaerts
 int wdh = abs((zielGeschw - aktGeschw)/10);
  for(int i=0; i<wdh; i++){
    if(aktGeschw < zielGeschw)
      aktGeschw += 10;
    else
      aktGeschw -= 10;
    mySerial.write(0xC1); 
    mySerial.write(aktGeschw); 
    mySerial.write(0xC9);
    mySerial.write(aktGeschw); 
    delay(200);
  }
}
  
  
 /* void links(int geschwindigkeit)
  { 
    
       mySerial.write(0xC2); //forward motor 1
       mySerial.write(geschwindigkeit); //Speedvalue from 0 to 127
       mySerial.write(0xCA); //forward motor 2
       mySerial.write(geschwindigkeit/2); //Speedvalue from 0 to 127
   
  } 
  
  void rechts(int geschwindigkeit)
  {
    
        mySerial.write(0xC2); //forward motor 1
        mySerial.write(geschwindigkeit/2); //Speedvalue from 0 to 127
        mySerial.write(0xCA); //forward motor 2
        mySerial.write(geschwindigkeit); //Speedvalue from 0 to 127
        
  }*/
  
  void drehenL(int geschwindigkeit) // dreht mit übergebener Geschwindigkeit nach links
  {
    
        mySerial.write(0xC2); //forward motor 1
        mySerial.write(geschwindigkeit); //Speedvalue from 0 to 127
        mySerial.write(0xC9); //forward motor 2
        mySerial.write(geschwindigkeit); //Speedvalue from 0 to 127 
       
  } 
  
  void drehenR(int geschwindigkeit) //dreht mit übergebener Geschwindigkeit nach rechts
  {
    
        mySerial.write(0xC1); //forward motor 1
        mySerial.write(geschwindigkeit); //Speedvalue from 0 to 127
        mySerial.write(0xCA); //forward motor 2
        mySerial.write(geschwindigkeit); //Speedvalue from 0 to 127
   
  } 
  
  void stoppen()// häöt den Roboter an. 1 da 0 eine Fehlermeldung ergibt.
  {
        mySerial.write(0xC1); 
        mySerial.write(1); 
        mySerial.write(0xCA);
        mySerial.write(1);
       aktGeschw = 0; 
   
  } 
  
  void drehenPhi()//dreht sich im den übergebenen Winkel zu einer Person
  {
    float winkel = atan(someX.value/someZ.value);
        int wdh = (int) winkel/4.5+0.5; // konvertierung des Winkels in die schleifenwiederholungen. +0.5 um zu runden
        for(int i = 0; i <= wdh; i++)
        {
        if(someX.value<0)   
          drehenL(80);
        else drehenR(80);
           
        delay(200);
        stoppen();
        delay(500); 
        }
          
    
    
  }
  
  void drehenb(){
    if(someX.value<0)   
          drehenL(80);
    else drehenR(80);  
    delay(200);
    stoppen();
    delay(500); 
  }
  

#endif

/////////////////////////////////////////////////////////  motor end  /////////////////////////////////////////////////////////
