

void initialization()
{

//--------------------------------------UART----------------------start
                  // I know that the last port in the serial list on my PC
                  // is always my  FTDI adaptor, so I open Serial.list()[Serial.list().length-1].
                  // If the whole thing does not work, try a different port... 
                  // you can also just directly use the port name  as a parameter:
                  // (i.e. type '"COM18"' instead of 'Serial.list()[Serial.list().length-1]')
                 
                  // Open whatever port is the one you're using.
                  String portName = Serial.list()[Serial.list().length-1];
                  
                  myPort = new Serial(this, portName, 115200); //open a connection with 115200Baud - this has to match the Baudrate in your Arduino sketch!
                  
                  frameRate(20);
                //------------------------------------------UART-------------------end  
    
                  size(640,480);
                  
                  context = new SimpleOpenNI(this);
                    
                                if(context.isInit() == false)
                                {
                                   
                                  println("Can't init SimpleOpenNI, maybe the camera is not connected!"); 
                                   exit();
                                   return;  
                                   
                                }
    
                  // enable depthMap generation 
                  context.enableDepth();
                   
                  // enable skeleton generation for all joints
                  context.enableUser();
                 
                  background(200,0,0);
                
                  stroke(0,0,255);
                  strokeWeight(3);
                  smooth();
                  
}
